package com.jniwrapper.win32.hook;

import com.jniwrapper.Bool;
import com.jniwrapper.Pointer;

/**
 * Provides implementation of low-lelel mouse hook.
 *
 * @author Serge Piletsky
 */
final public class LowLevelMouseHook extends LowLevelHook
{
    public LowLevelMouseHook()
    {
        super(Descriptor.MOUSE_LL);
    }

    protected long processEvent(long wParam, long lParam)
    {
        final Pointer.Void structureHandle = new Pointer.Void(lParam);

        final MouselHookStruct mouseStructure = new MouselHookStruct();
        final Pointer structurePointer = new Pointer(mouseStructure);
        structureHandle.castTo(structurePointer);
        structurePointer.setNull(true);

        final Bool consume = new Bool(false);

        final LowLevelMouseEvent event = new LowLevelMouseEvent(this, wParam, mouseStructure, consume);
        notifyListeners(event);

        if (consume.getValue())
        {
            return -1;
        }
        else
        {
            return 0;
        }
    }
}
